package org.openepics.names.rest.beans.element;

import java.io.Serializable;
import java.util.Objects;
import java.util.UUID;

import org.openepics.names.rest.beans.Type;

import io.swagger.v3.oas.annotations.media.Schema;

public class StructureElementCommandConfirm implements Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 4363449987852744536L;

    @Schema(description = "Identity (uuid) of the structure entry. Value is created server-side.")
    private UUID uuid;
    @Schema(description = "Type of the structure entry. Valid values - SYSTEMGROUP, SYSTEM, SUBSYSTEM, DISCIPLINE, DEVICEGROUP, DEVICETYPE.")
    private Type type;
    @Schema(description = "Comment of the structure entry command.")
    private String comment;

    /**
     * Public constructor.
     */
    public StructureElementCommandConfirm() {
    }

    /**
     * Public constructor.
     *
     * @param uuid uuid
     * @param type type
     * @param comment comment
     */
    public StructureElementCommandConfirm(
            UUID uuid, Type type, String comment) {
        super();
        this.uuid = uuid;
        this.type = type;
        this.comment = comment;
    }

    public UUID getUuid() {
        return uuid;
    }
    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }
    public Type getType() {
        return type;
    }
    public void setType(Type type) {
        this.type = type;
    }
    public String getComment() {
        return comment;
    }
    public void setComment(String comment) {
        this.comment = comment;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;

        return equals ((StructureElementCommandConfirm) obj);
    }

    public boolean equals(StructureElementCommandConfirm other) {
        if (other == null)
            return false;

        if (!super.equals(other)) {
            return false;
        }

        if (getUuid() == null) {
            if (other.getUuid() != null)
                return false;
        } else if (!getUuid().equals(other.getUuid()))
            return false;
        if (getType() == null) {
            if (other.getType() != null)
                return false;
        } else if (!getType().equals(other.getType()))
            return false;
        if (getComment() == null) {
            if (other.getComment() != null)
                return false;
        } else if (!getComment().equals(other.getComment()))
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                getUuid());
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        sb.append("\"uuid\": "                    + getUuid());
        sb.append(", \"type\": "                  + getType());
        sb.append(", \"comment\": "               + getComment());
        sb.append("}");
        return sb.toString();
    }

}
